HDU-2647 Reward(拓扑排序)

Reward

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Problem Description Dandelion’s uncle is a boss of a factory. As the spring festival is coming , he wants to distribute rewards to his workers. Now he has a trouble about how to distribute the rewards.

The workers will compare their rewards ,and some one may have demands of the distributing of rewards ,just like a’s reward should more than b’s.Dandelion’s unclue wants to fulfill all the demands, of course ,he wants to use the least money.Every work’s reward will be at least 888 , because it’s a lucky number.  

Input One line with two integers n and m ,stands for the number of works and the number of demands .(n<=10000,m<=20000)

then m lines ,each line contains two integers a and b ,stands for a’s reward should be more than b’s.  

Output For every case ,print the least money dandelion ‘s uncle needs to distribute .If it’s impossible to fulfill all the works’ demands ,print -1.  

Sample Input

2 1 1 2 2 2 1 2 2 1  

Sample Output

1777 -1  

Author dandelion

第一道拓扑排序题目,很简单,但是书上讲的是用栈实现的,不会应用在这道需要分层的题,看了别人用队列实现的感觉很简单易懂,便按照类似的思路写了一次,效率貌似有点低,毕竟用了vector和队列,还需要更多的练习

#include <cstdio>
#include <vector>
#include <queue>
#include <cstring>

using namespace std;

struct Node {
    int i,v;
    Node(int ii=0,int vv=0) {
        i=ii,v=vv;
    }
}u;

const int INF=0x3f3f3f3f;
const int MAXN=10005;
int n,m,cnt[MAXN],ans;
vector<vector<int> > v;
vector<int> t;

bool topo() {
    int i,j,num=0;
    queue<Node> q;
    ans=0;
    for(i=1;i<=n;++i)
        if(cnt[i]==0) {
            q.push(Node(i,888));
            ans+=888;
            ++num;
        }
    while(!q.empty()) {
        u=q.front();
        q.pop();
        for(i=0,j=(t=v[u.i]).size();i<j;++i)
            if((--cnt[t[i]])==0) {
                q.push(Node(t[i],u.v+1));
                ans+=u.v+1;
                ++num;
            }
    }
    return num==n;
}

int main() {
    int i,a,b;
    while(scanf("%d%d",&n,&m)==2) {
        v.clear();
        v.resize(n+1);
        memset(cnt,0,sizeof(cnt));
        for(i=0;i<m;++i) {
            scanf("%d%d",&a,&b);
            v[b].push_back(a);//由于a b表示a获得的钱比b多,则a一定比b后进入队列,即为b→a的有向边
            ++cnt[a];
        }
        printf("%d\n",topo()?ans:-1);
    }
    return 0;
}

    原文作者:拓扑排序
    原文地址: https://blog.csdn.net/idealism_xxm/article/details/47666925
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞